// Модель бака с жидкостью и тремя клапанами// ырф 240321
//все клапаны и их обратные связи идут по модбасу через Coils
#include <ModbusRtu.h>
//===
#define Klapan1 12 // выход управления клапаном 1 (налив)
#define Klapan2 11 // выход управления клапаном 2 (слив1)
#define Klapan3 10 // выход управления клапаном 3 (слив2)
//=======

#define ID   1      // адрес ведомого модбас
//
//Задаём ведомому модбаса адрес, последовательный порт, выход управления TX
Modbus slave(ID, 0, 0); 
int8_t state = 0; // байт состояния модбаса
 //
   // byte Rab = 0; 
    byte autoKey = 0; // ключ авторегулирования
     uint16_t deltaLevel = 3; // гистерезис
   uint16_t ustavkaLevel = 10; // уставка уровня
  //
//===============================
 // Обмен данными по модбасу идет через массив регистров
// 
uint16_t au16data[11];
  // раскладка массива:
   // Modbus Coils (битовая адресация):
  //адрес 0 ,бит 1 = клапан 1, налив 
//адрес 0 ,бит 2 = клапан 2, слив
//адрес 0 ,бит 3 = клапан 3, слив 
//адрес 0 ,бит 4 = ключ авторегулирования 
//адрес 0 ,бит 5 = клапан 1 обратная связь
//адрес 0 ,бит 6 = уровень клапан 2 обратная связь
//адрес 0 ,бит 7 = клапан 3 обратная связь
//адрес 0 ,бит 8 = авторегулирование обратная связь
// Modbus Holding Regisres: 
  // адрес 1  гистерезис уровня
  //адрес 2  уставка уровня
  //адрес 3 канал отладки
  //адрес 4 уровень

//============================
    void setup() {
        ///pinMode(pinLed, OUTPUT);  
          pinMode(Klapan1, OUTPUT);
             pinMode(Klapan2, OUTPUT);
               pinMode(Klapan3, OUTPUT);
          //
          // настраиваем последовательный порт ведомого
              slave.begin( 115200 ); 
}

//============================
  void loop()
{
    state = slave.poll( au16data, 11);  // если в обмене Модбас всё нормально
       if ( state > 4){
     //

   uint16_t voltage = analogRead(A0);
   //считываем напряжение с конденсатора (уровень в баке));
   autoKey = bitRead( au16data[0], 4 ); // получаем флаг авторегулирования уровня
  au16data[4]= voltage; // уровень загоняем в регистр 4 массива обмена модбас
     digitalWrite(Klapan2, bitRead( au16data[0], 2 ));  // управление клапаном 2
    digitalWrite(Klapan3, bitRead( au16data[0], 3 ));  // управление клапаном 3  
  //==
  //au16data[5]=digitalRead(Klapan1); // чтение состояния клапана 1 ================
  //au16data[6]=digitalRead(Klapan2); // чтение состояния клапана 2 ================
  //au16data[7]=digitalRead(Klapan3); // чтение состояния клапана 3 ================
 //=== au16data[8]= autoKey; // чтение состояния ключа авторегулирования ================
  //==
  bitWrite (au16data[0], 5, digitalRead(Klapan1)); // чтение состояния клапана 1 ================
  bitWrite (au16data[0], 6, digitalRead(Klapan2)); // чтение состояния клапана 2 ================
       bitWrite (au16data[0], 7, digitalRead(Klapan3)); // чтение состояния клапана 3 ================
  bitWrite (au16data[0], 8, autoKey); // чтение состояния ключа авторегулирования ================
//
  //au16data[3]= analogRead(A1);
 //
  // 
}
//
 manualLevel();
  autoLevel();
 }

//=============================
//ручное управление клапаном 1
void manualLevel()
{
if (autoKey == 1)
 {
 return;
 }
digitalWrite(Klapan1, bitRead( au16data[0], 1 ));  // управление клапаном 1
}

//===========================
// функция автоматического регулирования уровня согласно заданной уставке и гистерезису
// для нормальной работы включить слив - включить клапан 2
void autoLevel()
{
   ustavkaLevel = au16data[2]; // берем уставку уровня из массива модбаса
   deltaLevel = (au16data[1]); // считываем гистерезис
   //заблокируем режим авторегулирования если ключ=0
   if (autoKey == 0 )
 {
 return;
 }
   if  ((au16data[4]) > (ustavkaLevel + deltaLevel) ) {
   digitalWrite(Klapan1,LOW); // налив выключим
  //===============================================
   }
    else if  ((au16data[4]) < (ustavkaLevel - deltaLevel) ) {
    digitalWrite(Klapan1,HIGH); // налив включим
    //=============================================
    }
//au16data[1]= (ustavkaLevel + deltaLevel);
}
 
